/* Send and Receive ASCII command from a i7k/i8k/i87k modules via serial port.

   Author: Moki Matsushima

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

/* File level history (record changes for this file here.)

   v 0.0.0  26 January 2015 by Winson Chen
     create, blah blah... */

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include "msw.h"
#include "modbus.h"


int main(int argc, char **argv)
{
	int RetValue,slot,comport,timeout, addr, count, function, netid;
	char szBuf[80];
	DWORD baudrate;
	WORD wT, wValue,ao0,ao1,ao2;

		comport = 0;		//ttyS* or ttyUSB*
		baudrate = 9600;	//default baudrate
		netid = 1;		//NetID
		function = 16;		//Function code
		addr = 0;		//modbus address
		count = 3;		//Preset three ao channel
		wValue = 0;		//
		timeout = 100;

		ao0 = 5000;
		ao1 = 10000;
		ao2 = 7500;

		szBuf[0] = ao0 >> 8 & 0xff;
		szBuf[1] = ao0 & 0xff;
		szBuf[2] = ao1 >> 8 & 0xff;
		szBuf[3] = ao1 & 0xff;
		szBuf[4] = ao2 >> 8 & 0xff;
		szBuf[5] = ao2 & 0xff;

	/* open device file */
	RetValue = Open_Com(comport, baudrate, Data8Bit, NonParity, OneStopBit);

	if (RetValue >0) {
		printf("open COM%d failed!\n",comport);
		return FAILURE;
	}

	RetValue = modbusRequest(comport, netid, function, addr, count, szBuf, sizeof(szBuf), timeout, &wT);
	Close_Com(comport);

	if (RetValue == 0) {
		printf("OK\n");
		return NoError;
	} else if (RetValue == CmdError) {
		printf("Module at COM%d return error code %d !!!\n",comport,szBuf[0]);
		return FAILURE;
	} else {
		printf("Module at COM%d error %d !!!\n",comport,RetValue);
		return FAILURE;
	}
}
