/* Send and Receive ASCII command from a i7k/i8k/i87k modules via serial port.

   Author: Moki Matsushima

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

/* File level history (record changes for this file here.)

   v 0.0.0  26 Jan 2015 by Winson Chen
     create, blah blah... */

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include "msw.h"
#include "modbus.h"

void	usage(void);

int main(int argc, char **argv)
{
	int RetValue,slot,comport,timeout, addr, count, function, netid;
	unsigned char szBuf[80];
	DWORD baudrate[8] = {9600,115200,1200,2400,4800,19200,38400,57600};
	WORD wT;
	int i = 0, len = 0;

	if (argc == 2) {
		comport = atoi(argv[1]);
	}
	else {
		usage();
		return FAILURE;
	}

	memset(szBuf, 0, sizeof(szBuf));

	/* open device file */

	while(i < 8)
	{
		netid = 1;
		RetValue = Open_Com(comport, baudrate[i++], Data8Bit, NonParity, OneStopBit);
		if (RetValue > 0) {
			printf("open COM%d failed!\n",comport);
			return FAILURE;
		}
		
		while(netid <= 247 )
		{
			
			RetValue = modbusRequest(comport, netid++, 70, 0, 0, szBuf, sizeof(szBuf), 40, &wT);

			if(szBuf[0] != 0 || szBuf[1] != 0)
                	{
                        	int len = 0;
	                        while(len < 4)
        	                {
                	                printf("0x%02x ", szBuf[len]);
                        	        len++;
	                        }
        	                printf("\n");
                	        printf("Netid is %d  Baud rate is %d\n",netid - 1,baudrate[i - 1]);
				memset(szBuf, 0, sizeof(szBuf));
	                }

		}

		Close_Com(comport);
	}

	return 0;

}

void usage(void)
{
	printf("ICPDAS M-7000 Library ver %s\n",M7000_LIB_VER);
	printf("function : modbus utility\n");
	printf("select comport and find device information (for 8N1 mode)\n");
	printf("Usage: Modbus_utility comport\n");
	printf("If comport is 0, means /dev/ttyS0 or /dev/ttyUSB0\n");
	printf("Example 1:Modbus_utility 0\n");
}
