/**********************************************************************
 *
 *  msw.h
 *
 *  Header for msw.c (Microsoft Windows Warp)
 *
 *  Since 1999.10.27 by Reed Lai
 *
 **********************************************************************/
/* *INDENT-OFF* */
#ifndef _MSW_H
#define _MSW_H

#include "m7k.h"
#include "common.h"
#include "slot.h"
//#include "lincon.h"

#define DEFAULT_READ_BUF_SIZE 250

#define MAX_CMD_SIZE  250

#define COM2          0
#define COM3          1
#define COM4          2
#define COM5          3
#define COM6          4
#define COM7          5
#define COM8          6
#define COM9          7
#define COM10         8
#define COM11         9
#define COM12         10
#define COM13         11
#define COM14         12
#define COM15         13
#define COM16         14
#define COM17         15
#define COM18         16
#define COM19         17
#define COM20         18
#define COM21         19
#define COM22         20
#define COM23         21
#define COM24         22
#define COM25         23
#define COM26         24
#define COM27         25
#define COM28         26
#define COM29         27
#define COM30         28
#define COM31         29
#define COM32         30
#define COM33         31
#define COM34         32
#define COM35         33
#define COM36         34

#ifdef USB //init for USB
#define MAX_COM_PORTS 16
#define USB0          0
#define USB1          1
#define USB2          2
#define USB3          3
#define USB4          4
#define USB5          5
#define USB6          6
#define USB7          7
#define USB8          8
#define USB9          9
#define USB10         10
#define USB11         11
#define USB12         12
#define USB13         13
#define USB14         14
#define USB15         15
#else
#define MAX_COM_PORTS 34
#define TTYS0		0
#define TTYS1		1
#define TTYS2		2
#define TTYS3		3
#define TTYS4		4
#define TTYS5		5
#define TTYS6		6
#define TTYS7		7
#define TTYS8		8
#define TTYS9		9
#define TTYS10		10
#define TTYS11		11
#define TTYS12		12
#define TTYS13		13
#define TTYS14		14
#define TTYS15		15
#define TTYS16		16
#define TTYS17		17
#define TTYS18		18
#define TTYS19		19
#define TTYS20		20
#define TTYS21		21
#define TTYS22		22
#define TTYS23		23
#define TTYS24		24
#define TTYS25		25
#define TTYS26		26
#define TTYS27		27
#define TTYS28		28
#define TTYS29		29
#define TTYS30		30
#define TTYS31		31
#define TTYS32		32
#define TTYS33		33
#define TTYS34		34
#endif

#define    Data5Bit                     5
#define    Data6Bit                     6
#define    Data7Bit                     7
#define    Data8Bit                     8

#define    NonParity                    0
#define    OddParity                    1
#define    EvenParity                   2

#define    OneStopBit                   0
#define    One5StopBit                  1
#define    TwoStopBit                   2


#define __declspec(dllexport)
#define EXPORTS
#define CALLBACK
#define WINAPI
#define FAR
#define NEAR

typedef __bool_t BOOL;

typedef u_byte_t BYTE;
typedef u_word_t WORD;
typedef u_dword_t DWORD;

typedef unsigned char UCHAR;

extern int _fd[];

extern EXPORTS WORD CALLBACK Receive_Cmd(char cPort, char szResult[],										 WORD wTimeOut, WORD wChksum);
extern EXPORTS WORD CALLBACK Send_Receive_Cmd(char cPort, char szCmd[], 
		char szResult[], WORD wTimeOut,WORD wChksum, WORD * wT);
extern EXPORTS WORD CALLBACK Send_Cmd(char cPort, char szCmd[], WORD wChksum);
extern EXPORTS BOOL CALLBACK Close_Com(char port);
extern EXPORTS WORD CALLBACK Open_Com(char port, DWORD baudrate, char cData,									char cParity, char cStop);
extern WORD Send_Receive(char cPort, char szCmd[], WORD wLen, char szResult[],								WORD wLenR, WORD wTimeOut, WORD *wT);
/* Macros to warp MS-Windows functions */
#define Sleep(a)

/* Macros to warp Turbo C functions */
#define getch()   (int)getchar()
#define getche()  (int)getchar()
#define kbhit()   (int)getchar()

/* Macros to warp DOS functions */
#define RECEIVE_CMD(a, b, c, d) (int)Receive_Cmd((char)(a), (b), (long)(c), (int)(d))
#define SEND_CMD(a,b,c,d) (int)Send_Cmd((char)(a), (b), (WORD)(d))
#define OPEN_COM(p,b)     (int)Open_Com((char)(p), (DWORD)(b), Data8Bit, NonParity, OneStopBit)
#define CLOSE_COM(p)      (int)Close_Com((char)(p))

#include "m7000.h"
#endif							/* _MSW_H */
